//+------------------------------------------------------------------+
//|                        Digital Low Pass (FATL/SATL, KGLP) Filter |
//|                      Copyright (c) Sergey Iljukhin, Novosibirsk. |
//|                        mailto:sergey@tibet.ru  http://fx.qrz.ru/ |
//+------------------------------------------------------------------+
#property copyright "Copyright (c) 2005, Sergey Iljukhin, Novosibirsk"
#property link      "mailto:sergey@tibet.ru"

/*

     MetaTrader 4.
 
  !      DLL 
      - bdsp.dll, lapack.dll, mkl_support.dll,
       C:\Windows\System32\    DF.dll  \experts\libraries\
 
    :
  
  1.    "Allow DLL import"  "Confirm DLL function's call"   Options->Expert Advisors
  2.    C:\Windows\System32\  Bdsp.dll, lapack.dll, mkl_support.dll -   . 
 
    :
  
  Ftype -  : 0 -  (FATL/SATL/KGLP), 1 -  (KGHP), 
          2 -  (RBCI/KGBP), 3 -  (KGBS)
  P1 -      P1, 
  D1 -        D1, 
  A1 -        1, 
  P2 -      P2, 
  D2 -        D2, 
  A2 -        2, 
  Ripple -    , 
  Delay - , 

        P2,D2,A2 
   :
  : P1>D1
  : P1<D1
    : D2>P2>P1>D1

*/

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

#import "DF.dll"
 int DigitalFilter(int FType, int P1, int D1, int A1, int P2, int D2, int A2,
                   double Ripple, int Delay, double& arr[]); 

//   
extern int FType=0;
extern int P1=28;
extern int D1=19;
extern int A1=40;
extern int P2=0;
extern int D2=0;
extern int A2=0;
extern int Delay=0;
extern double Ripple=0.08; 
int FilterSize=0;
extern int BarShift=0; //  , .  - ,  - 

//---- buffers
double FilterResponse[], FilterBuffer[1500];

//+------------------------------------------------------------------+
//| Digital filter indicator initialization function                 |
//+------------------------------------------------------------------+
int init()
{

 if(IsDllsAllowed()!=false)
  {
  //---- indicator line
  SetIndexStyle(0,DRAW_LINE);
  SetIndexBuffer(0,FilterResponse);

  //   
  FilterSize=DigitalFilter(FType, P1, D1, A1, P2, D2, A2, Ripple, Delay, FilterBuffer); 
  if (FilterSize>0) {
    SetIndexDrawBegin(0,FilterSize);
  } else Print("Incorrect input parameters. Indicator cannot run.");
  } else Print("Library call is not allowed. Indicator cannot run.");

//----
return(0);
}
//+------------------------------------------------------------------+
//| Digital filter main function                                     |
//+------------------------------------------------------------------+
int start()
{
int i, j, counted_bars=IndicatorCounted();

if(IsDllsAllowed()!=false)
 {
 if (FilterSize>0) {

  //----
  if(Bars<=FilterSize) return(0);

  //----
  i=Bars-FilterSize-1;
  if(counted_bars>=FilterSize) i=Bars-counted_bars-1;
  while(i>=0)
  {
   FilterResponse[i-BarShift]=0;
   for (j=0; j<FilterSize; j++) 
     FilterResponse[i-BarShift]=FilterResponse[i-BarShift]+FilterBuffer[j]*Close[i+j];
   
     //FilterResponse[i]=Close[i];
  i--;
  }

  } else Print("Incorrect input parameters. Indicator cannot run.");
  } else Print("Library call is not allowed. Indicator cannot run.");

return(0);
}